Index: asterisk/apps/app_forkcdr.c
===================================================================
RCS file: /usr/cvsroot/asterisk/apps/app_forkcdr.c,v
retrieving revision 1.10
diff -u -r1.10 app_forkcdr.c
--- asterisk/apps/app_forkcdr.c	15 Jul 2005 23:00:46 -0000	1.10
+++ asterisk/apps/app_forkcdr.c	16 Jul 2005 05:41:53 -0000
@@ -40,28 +40,21 @@
 
 LOCAL_USER_DECL;
 
-
-static void ast_cdr_clone(struct ast_cdr *cdr) 
-{
-	struct ast_cdr *newcdr = ast_cdr_alloc();
-	memcpy(newcdr,cdr,sizeof(struct ast_cdr));
-	ast_cdr_append(cdr,newcdr);
-	newcdr->start = ast_tvnow();
-	memset(&newcdr->answer, 0, sizeof(newcdr->answer));
-	memset(&newcdr->varshead, 0, sizeof(newcdr->varshead));
-	ast_cdr_copy_vars(newcdr, cdr);
-	if (!ast_test_flag(cdr, AST_CDR_FLAG_KEEP_VARS)) {
-		ast_cdr_free_vars(cdr, 0);
-	}
-	newcdr->disposition = AST_CDR_NOANSWER;
-	ast_set_flag(cdr, AST_CDR_FLAG_CHILD|AST_CDR_FLAG_LOCKED);
-}
-
 static void ast_cdr_fork(struct ast_channel *chan) 
 {
-	if(chan && chan->cdr) {
-		ast_cdr_clone(chan->cdr);
-	}
+	struct ast_cdr *cdr;
+	struct ast_cdr *newcdr;
+	if (!chan || !(cdr = chan->cdr))
+		return;
+	while (cdr->next)
+		cdr = cdr->next;
+	if (!(newcdr = ast_cdr_dup(cdr)))
+		return;
+	ast_cdr_append(cdr, newcdr);
+	ast_cdr_reset(newcdr, AST_CDR_FLAG_KEEP_VARS);
+	if (!ast_test_flag(cdr, AST_CDR_FLAG_KEEP_VARS))
+		ast_cdr_free_vars(cdr, 0);
+	ast_set_flag(cdr, AST_CDR_FLAG_CHILD | AST_CDR_FLAG_LOCKED);
 }
 
 static int forkcdr_exec(struct ast_channel *chan, void *data)
Index: asterisk/include/asterisk/cdr.h
===================================================================
RCS file: /usr/cvsroot/asterisk/include/asterisk/cdr.h,v
retrieving revision 1.27
diff -u -r1.27 cdr.h
--- asterisk/include/asterisk/cdr.h	3 Jun 2005 01:42:31 -0000	1.27
+++ asterisk/include/asterisk/cdr.h	16 Jul 2005 05:41:53 -0000
@@ -104,6 +104,12 @@
  */
 extern struct ast_cdr *ast_cdr_alloc(void);
 
+/*! Duplicate a record */
+/*! 
+ * Returns a malloc'd ast_cdr structure, returns NULL on error (malloc failure)
+ */
+extern struct ast_cdr *ast_cdr_dup(struct ast_cdr *cdr);
+
 /*! Free a record */
 /* \param cdr ast_cdr structure to free
  * Returns nothing important
Index: asterisk/cdr.c
===================================================================
RCS file: /usr/cvsroot/asterisk/cdr.c,v
retrieving revision 1.50
diff -u -r1.50 cdr.c
--- asterisk/cdr.c	15 Jul 2005 23:00:46 -0000	1.50
+++ asterisk/cdr.c	16 Jul 2005 05:41:53 -0000
@@ -147,7 +147,7 @@
 	AST_LIST_UNLOCK(&be_list);
 }
 
-static struct ast_cdr *cdr_dup(struct ast_cdr *cdr) 
+struct ast_cdr *ast_cdr_dup(struct ast_cdr *cdr) 
 {
 	struct ast_cdr *newcdr;
 
@@ -809,7 +809,7 @@
 		if (ast_test_flag(&tmp, AST_CDR_FLAG_LOCKED) || !ast_test_flag(cdr, AST_CDR_FLAG_LOCKED)) {
 			if (ast_test_flag(&tmp, AST_CDR_FLAG_POSTED)) {
 				ast_cdr_end(cdr);
-				if ((dup = cdr_dup(cdr))) {
+				if ((dup = ast_cdr_dup(cdr))) {
 					ast_cdr_detach(dup);
 				}
 				ast_set_flag(cdr, AST_CDR_FLAG_POSTED);
